- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Types | Public Member Functions | Related Functions
ScaleMap< M, C > Class Template Reference
Map Adaptors

## Detailed Description

### template<typename M, typename C = typename M::Value>
class lemon::ScaleMap< M, C >

This read-only map returns the value of the given map multiplied from the left side with a constant value. Its `Key` and `Value` are inherited from `M`.

Actually,

* ScaleMap<M> sc(m,v);
*

is equivalent to

* ConstMap<M::Key, M::Value> cm(v);
* MulMap<ConstMap<M::Key, M::Value>, M> sc(cm,m);
*

The simplest way of using this map is through the scaleMap() function.

See Also
  ScaleWriteMap

`#include <lemon/maps.h>`

Inheritance diagram for ScaleMap< M, C >:
[legend]

## Public Types
typedef M::Key | Key
typedef M::Value | Value
Public Types inherited from MapBase< M::Key, M::Value >
typedef M::Key | Key
| The key type of the map.
typedef M::Value | Value
| The value type of the map. (The type of objects associated with the keys).

## Public Member Functions
| ScaleMap (const M &m, const C &v)
| Constructor. More...
Value | operator[] (const Key &k) const

## Related Functions
(Note that these are not member functions.)
template<typename M , typename C >
ScaleMap< M, C > | scaleMap (const M &m, const C &v)
| Returns a `ScaleMap` class. More...

## Constructor & Destructor Documentation

ScaleMap | ( | const M & | m,
|  | const C & | v
| ) |  |
| inline

Constructor.

Parameters

  m | The undelying map.
  v | The constant value.